import unittest
import io
import contextlib
from unittest.mock import patch

from tmc import points

from tmc.utils import load, get_stdout
main = load('src.main', 'main')
factorial = load('src.main','factorial')

@points('4.4')
class MainTest(unittest.TestCase):
    def test_00_something_is_printed(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        if not printed:
            self.fail('Et tulostanut mitään!')

    def test_01_prints_correct_first_line(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[0].strip()
        self.assertEquals(line, 'Taulukon a+b pienin ja suurin alkio: -12.900, 19.300', msg='Tarkista ensimmäisen rivin tulostus.')

    def test_02_prints_correct_second_line(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[1].strip()
        self.assertEquals(line, 'Taulukon a*b pienin suurin alkio: -89.500, 92.700', msg='Tarkista toisen rivin tulostus.')

    def test_03_prints_correct_third_line(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[2].strip()
        self.assertEquals(line, 'Taulukon sin(a+b) pienin ja suurin alkio: -0.978, 0.999', msg='Tarkista kolmannen rivin tulostus.')

    def test_04_prints_correct_fourth_line(self):
        self.longMessage = False
        main()
        printed = get_stdout()
        line = printed.split('\n')[3].strip()
        self.assertEquals(line, 'Taulukon (a+b)**3 pienin ja suurin alkio: -2146.689, 7189.057', msg='Tarkista neljännen rivin tulostus.')





